#!/usr/bin/perl 
#
#   MiniM Server Connect
#   ActivePerl example to call minimsc.dll
#   (L) Onix , e-mail: azbuka@rbcmail.ru, ICQ:144312645 
#

use Win32::API;

	Win32::API::Struct->typedef( MINIMSTR => qw{
   		USHORT len;	UCHAR  data[32768];
	});

	Win32::API->Import('minimsc.dll', 'MNMCreateConnect','PNP','L');
	Win32::API->Import('minimsc.dll', 'MNMConnectOpen',  'L',  'L');
	Win32::API->Import('minimsc.dll', 'MNMGetLastError', 'LS', 'L');
	Win32::API->Import('minimsc.dll', 'MNMRead',         'LSS','L');
	Win32::API->Import('minimsc.dll', 'MNMWrite',        'LSS','L');
	Win32::API->Import('minimsc.dll', 'MNMConnectClose',   'L','L');
	Win32::API->Import('minimsc.dll', 'MNMDestroyConnect', 'L','L');
	Win32::API->Import('minimsc.dll', 'MNMExecute',       'LS','L');
	Win32::API->Import('minimsc.dll', 'MNMKill',    'LS','L');
	Win32::API->Import('minimsc.dll', 'MNMListGet',    'SNS','L');
	Win32::API->Import('minimsc.dll', 'MNMListSet',    'SNS','L');
	Win32::API->Import('minimsc.dll', 'MNMText',       'SS','L');


my $server="localhost";
my $database="user";
my $port=5000;
my $connect;
my $ret;

# create connection object
	$connect = MNMCreateConnect($server,$port,$database);

# connect to server
	$ret = MNMConnectOpen($connect);

my $err   = Win32::API::Struct->new('MINIMSTR');
my $expr  = Win32::API::Struct->new('MINIMSTR');
my $value = Win32::API::Struct->new('MINIMSTR');

# evaluate mumps expression  $zversion_" "_$h
my $cmd = q/$zversion_" "_$h/;

	$expr->{data} = $cmd;
	$expr->{len} = length $cmd;

	$ret = MNMRead( $connect, $expr, $value);

	print "result:", substr($value->{data},0,$value->{len}),"\n";

#  execute commands
	$expr->{data} = q/s a=123,b="Hello, world!"/;
  	$expr->{len} = length $expr->{data};

  	$ret = MNMExecute($connect, $expr);

#  build list
  	$expr->{data} = q/$lb(a,b,"Hello, mumps!")/;
  	$expr->{len} =length $expr->{data};

  	MNMRead($connect,$expr,$value);

my $element = Win32::API::Struct->new('MINIMSTR');

for (my $i=1; $i<=3; $i++) {
  	MNMListGet($value, $i, $element);
	print "item[$i]:", substr($element->{data},0,$element->{len}),"\n";
}

# close connection to server
	MNMConnectClose($connect);

# destroy connection object  
  MNMDestroyConnect($connect);

# print decorated strings

my $Source = Win32::API::Struct->new('MINIMSTR');
my $Target = Win32::API::Struct->new('MINIMSTR');

my @strings = ( "abcd", "ab\"cd", "ab\r\ncd" );
  foreach $string(@strings) {
    $Source->{data} = $string;
    $Source->{len} = length $string;
    MNMText( $Source, $Target);
    print substr( $Target->{data},0,$Target->{len}),"\n";
  }

	exit;
