/*
 
    MiniM
    C# example how to call MiniM Server Connect
 
*/

using System;
using System.Collections.Generic;
using System.Text;
using MiniMExamples;

namespace Example3
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("C# example how to call MiniM Server Connect");
            
            MiniMSC.MINIMSTR Source = new MiniMSC.MINIMSTR();
            MiniMSC.MINIMSTR Target = new MiniMSC.MINIMSTR();

            String[] strings = { "abcd", "ab\"cd", "ab\r\ncd" };
            for (int i = 0; i < 3; i++)
            {
                MiniMSC.StringToMINIMSTR( strings[i],ref Source);
                MiniMSC.MNMText( ref Source, ref Target);
                Console.WriteLine( "{0}: {1}", i, MiniMSC.MINIMSTRToString( ref Target));
            }
            Console.WriteLine( "Example finished, press any key.");
            Console.ReadKey( false);
            return;
        }
    }
}
