program example3;

{$AppType CONSOLE}

uses
  Windows,
  SysUtils,
  minimscint;

function ToString( Str: PMINIMSTR): String;
var
  p: PChar;
begin
  p := @(Str^.data);
  SetString( Result, p, Str^.len);
end;

procedure ToMNMString( const Source: String; Dest: PMINIMSTR );
var
  len: Integer;
  p: Pchar;
begin
  len := Length( Source);
  Dest^.len := len;
  p := @(Dest^.data);
  CopyMemory( p, PChar( Source), len);
end;

var
  Source: MINIMSTR;
  Target: MINIMSTR;
  strings: array[ 0..2 ] of string =
  (
    'abcd',
    'ab"cd',
    'ab'#13#10'cd'
  );
  i: Integer;

begin

  WriteLn( 'Delphi example how to call MiniM Server Connect');

  WriteLn( 'M-decorated strings are:');
  for i := Low( strings) to High( strings) do
  begin
    ToMNMString( strings[ i], @Source);
    MNMText( @Source, @Target);
    WriteLn( IntToStr( i) + ': ' + ToString( @Target));
  end;

  WriteLn( 'Example finished, press enter...');
  ReadLn;

end.
