/*

    MiniM
    
    Java example how to call MiniM Server Connect

*/

// implement MiniM Server Connect output functionality
class OutputExample implements minimscj.Output
{
	public void Output( minimscj Connect, String Value)
	{
		System.out.print( Value);
		return;
	};
};

class example2 
{
	public static void main(String[] args)
	{
		try
		{

		System.out.println("Java example how to call MiniM Server Connect");

		// create connect to MiniM
		// setup need ANSI <-> Unicode code page conversion
		// "Cp1251" is Windows Cyrillic code page, it is example only
		minimscj Connect = new minimscj( "localhost", 5000, "user", "Cp1251");

		// open connect to MiniM
		Connect.ConnectOpen();

		OutputExample out = new OutputExample();
		Connect.SetOutput( out);

		// execute commands and accept output using out object
		Connect.ExecuteOutput( 
			"s list=$v(\"db\",15) f i=1:1:$l(list,\"*\") w $p(list,\"*\",i),!");

		// disconnect from MiniM
		Connect.ConnectClose();

		// remove connect
		Connect.DestroyConnect();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};