/*

    MiniM

    C++ example to call MiniM Server Connect

*/

#include <stdlib.h>
#include <stdio.h>

#include "minimsc.h"

int main(int argc, char* argv[])
{
  printf( "C++ example how to call MiniM Server Connect\n");

  MINIMSTR Source;
  MINIMSTR Target;
                        
  const char* source[] =
  {
    "abcd",
    "ab\"cd",
    "ab\r\ncd"
  };
  printf( "M-decorated strings are:\n");
  for( int i = 0; i < sizeof( source) / sizeof( source[ 0]); i++)
  {
    Source.len = sprintf( (char*)Source.data, "%s", source[ i]);
    MNMText( &Source, &Target);
    printf( "%d: %.*s\n", i, Target.len, Target.data);
  }

  printf( "Example finished, press Enter.");
  fgetc( stdin);

  return 0;
};
 