program example3;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this }
  , SysUtils, StrUtils, minimscint;

{$IFDEF WINDOWS}{$R example3.rc}{$ENDIF}

function ToString( Str: PMINIMSTR): String;
var
  p: PChar;
begin
  p := @(Str^.data);
  SetString( Result, p, Str^.len);
end;

procedure memcpy(dest, source: Pointer; count: Integer);cdecl;
begin
  Move(source^, dest^, count);
end;

procedure ToMNMString( const Source: String; Dest: PMINIMSTR );
var
  len: Integer;
  p: Pchar;
  src: PChar;
begin
  len := Length( Source);
  Dest^.len := len;
  p := PChar( @Dest^.data);
  src := PChar(Source);
  memcpy( p, src, len);
end;

var
  Source: MINIMSTR;
  Target: MINIMSTR;
  strings: array[ 0..2 ] of string =
  (
    'abcd',
    'ab"cd',
    'ab'#13#10'cd'
  );
  i: Integer;

begin

  WriteLn( 'Lazarus example how to call MiniM Server Connect');

  WriteLn( 'M-decorated strings are:');
  for i := Low( strings) to High( strings) do
  begin
    ToMNMString( strings[ i], @Source);
    MNMText( @Source, @Target);
    WriteLn( IntToStr( i) + ': ' + ToString( @Target));
  end;

  WriteLn( 'Example finished, press enter...');
  ReadLn;

end.

