{

    MiniM

    MiniM Server Connect interface
    Lazarus for Linux

    Copyright (C) Eugene Karataev

}

unit minimscint;

interface

// uses
//   Windows;

type

MINIMSTR = packed record
  len: Word;
  data: array[ 1 .. 32 * 1024 ] of Byte
end;

PMINIMSTR = ^MINIMSTR;

HMNMConnect = Pointer;

TMNMOutputProc = procedure( Connect: HMNMConnect; Value: PMINIMSTR); stdcall;

TMNMGroupReadProc = procedure( Connect: HMNMConnect; Value: PMINIMSTR); stdcall;

TMNMCallbackProc = procedure( Connect: HMNMConnect; Command: PMINIMSTR;
  Answer: PMINIMSTR); stdcall;

function MNMCreateConnect( server: PChar; port: Integer;
  database: PChar): HMNMConnect; stdcall;
  external 'minimsc' name 'MNMCreateConnect';

procedure MNMDestroyConnect( Connect: HMNMConnect); stdcall;
  external 'minimsc' name 'MNMDestroyConnect';

function MNMConnectOpen( Connect: HMNMConnect): Integer; stdcall;
  external 'minimsc' name 'MNMConnectOpen';

function MNMConnectClose( Connect: HMNMConnect): Integer; stdcall;
  external 'minimsc' name 'MNMConnectClose';

procedure MNMGetLastError( Connect: HMNMConnect; Error: PMINIMSTR); stdcall;
  external 'minimsc' name 'MNMGetLastError';

function MNMRead( Connect: HMNMConnect; Expression: PMINIMSTR;
  Res: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMRead';

function MNMWrite( Connect: HMNMConnect; VarName: PMINIMSTR;
  VarValue: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMWrite';

function MNMExecute( Connect: HMNMConnect; Commands: PMINIMSTR): Integer;
  stdcall; external 'minimsc' name 'MNMExecute';

function MNMKill( Connect: HMNMConnect; VarName: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMKill';

procedure MNMSetOutput( Connect: HMNMConnect; Proc: TMNMOutputProc); stdcall;
  external 'minimsc' name 'MNMSetOutput';

procedure MNMSetGroupRead( Connect: HMNMConnect; Proc: TMNMGroupReadProc);
  stdcall; external 'minimsc' name 'MNMSetGroupRead';

procedure MNMSetCallback( Connect: HMNMConnect; Proc: TMNMCallbackProc);
  stdcall; external 'minimsc' name 'MNMSetCallback';

procedure MNMExecuteOutput( Connect: HMNMConnect; Commands: PMINIMSTR);
  stdcall; external 'minimsc' name 'MNMExecuteOutput';

function MNMListGet( List: PMINIMSTR; Pos: Integer;
  Element: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMListGet';

function MNMListSet( List: PMINIMSTR; Pos: Integer;
  Element: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMListSet';

function MNMListLength( List: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMListLength';

function MNMText( Source: PMINIMSTR; Target: PMINIMSTR): Integer; stdcall;
  external 'minimsc' name 'MNMText';

implementation

begin
end.
