﻿'
' 
' MiniM
' VB.NET example how to call MiniM Server Connect
' 
'
Imports System
Imports System.Collections.Generic
Imports System.Text
' Imports MiniMExamples

Module Example2
    Sub OutputStr(ByVal MNMConnect As IntPtr, ByRef Value As MiniMSC.MINIMSTR)
        Console.Write(MiniMSC.MINIMSTRToString(Value))
        Exit Sub
    End Sub

    Sub Main(ByVal args As String())
        Console.WriteLine("VB.NET example how to call MiniM Server Connect")

        Dim Connect As New MiniMSC()

        ' see default connection parameters in class MiniMSC
        ' and change one here if need

        Connect.CreateConnect()
        If Not Connect.ConnectOpen() Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If

        ' set output notifier function
        Connect.SetOutput(New MiniMSC.OutputProc(AddressOf OutputStr))

        Console.WriteLine("MiniM database list:")

        Dim Commands As New MiniMSC.MINIMSTR()
        MiniMSC.StringToMINIMSTR("s list=$v(""db"",15) f i=1:1:$l(list,""*"") w $p(list,""*"",i),!", Commands)

        ' execute code to get database list
        Connect.ExecuteOutput(Commands)

        ' disconnect from MiniM
        Connect.ConnectClose()

        ' remove connect
        Connect.DestroyConnect()

        Console.ReadKey()
    End Sub
End Module
