﻿'
' 
' MiniM
' VB.NET example how to call MiniM Server Connect
' 
'
Imports System
Imports System.Collections.Generic
Imports System.Text
' Imports MiniMExamples

Module Example4
    Public Sub GroupReadHandler(ByVal MNMConnect As IntPtr, ByRef Value As MiniMSC.MINIMSTR)
        Dim Name As New MiniMSC.MINIMSTR()
        Dim [Date] As New MiniMSC.MINIMSTR()
        MiniMSC.MNMListGet(Value, 1, Name)
        MiniMSC.MNMListGet(Value, 2, [Date])
        Console.WriteLine("Routine name: {0}, date change: {1}", MiniMSC.MINIMSTRToString(Name), MiniMSC.MINIMSTRToString([Date]))
        Exit Sub
    End Sub

    Sub Main(ByVal args As String())
        Console.WriteLine("VB.NET example how to call MiniM Server Connect")

        Dim Connect As New MiniMSC()

        ' see default connection parameters in class MiniMSC
        ' and change one here if need

        Connect.CreateConnect()
        If Not Connect.ConnectOpen() Then
            Console.WriteLine("MiniM error: {0}", Connect.GetLastError())
            Console.ReadKey()
            Exit Sub
        End If

        ' get routine's list as $lb( name , date )

        Connect.SetGroupRead(New MiniMSC.GroupReadProc(AddressOf GroupReadHandler))
        Dim Commands As New MiniMSC.MINIMSTR()

        MiniMSC.StringToMINIMSTR("s i="""" f  s i=$o(^ROUTINE(i)) q:i=""""   d wo^%srv($lb(i,$zd($g(^ROUTINE(i,0)),3)))", Commands)

        Connect.Execute(Commands)

        Connect.SetGroupRead(Nothing)

        ' disconnect from MiniM
        Connect.ConnectClose()

        ' remove connect
        Connect.DestroyConnect()

        Console.ReadKey()
    End Sub
End Module

