' MiniM VBS Example how to call MiniM Server Connect

WScript.Echo "VBS example how to call MiniM Server Connect"

Dim Connect

Set Connect = CreateObject( "MiniM.ServerConnect")

Connect.CreateConnect "localhost", 5000, "user"

Connect.Open

Dim str

' read M expression as string
str = Connect.ReadStr( "$zversion")
WScript.Echo "MiniM version: " & str

' execute commands
Connect.ExecuteStr "s a=123,b=456"

' read 2 variables as list
Dim List,Expr,Elem
Set List = CreateObject( "MiniM.ServerString")
Set Expr = CreateObject( "MiniM.ServerString")
Set Elem = CreateObject( "MiniM.ServerString")

' read as binary data
Expr.Value = "$lb(a,b)"
Connect.Read Expr, List

WScript.Echo "List length: " & Connect.ListLength( List)

' unpack list structure
Connect.ListGet List, 1, Elem
WScript.Echo "First list item is: " & Elem.Value

Connect.ListGet List, 2, Elem
WScript.Echo "Second list item is: " & Elem.Value

Connect.Close

Connect.DestroyConnect

Set Connect = Nothing
