/*

    MiniM
    
    Java example how to call MiniM Server Connect

*/

// implement MiniM Server Connect group read functionality

class GroupReadExample implements minimscj.GroupRead
{
	public void GroupRead( minimscj Connect, String Value)
	{
		try
		{
			System.out.println( "Routine name: " + Connect.ListGet( Value, 1) +
				", date change: " + Connect.ListGet( Value, 2));
			return;
		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
	};
};

class example4 
{
	public static void main(String[] args)
	{
		try
		{

		System.out.println("Java example how to call MiniM Server Connect");

		// create connect to MiniM
		// setup need ANSI <-> Unicode code page conversion
		// "Cp1251" is Windows Cyrillic code page, it is example only
		minimscj Connect = new minimscj( "localhost", 5000, "%sys", "Cp1251");

		// open connect to MiniM
		Connect.ConnectOpen();

		// get routine's list as $lb( name , date )

		GroupReadExample gr = new GroupReadExample();
		Connect.SetGroupRead( gr);
		
		Connect.Execute( "s i=\"\" f  s i=$o(^ROUTINE(i)) q:i=\"\"  d wo^%srv($lb(i,$zd($g(^ROUTINE(i,0)),3)))");

		Connect.SetGroupRead( null);

		// disconnect from MiniM
		Connect.ConnectClose();

		// remove connect
		Connect.DestroyConnect();

		}
		catch(Throwable e)
		{
			e.printStackTrace();
		}
		return;
	};
};